
#pragma warning (disable:4786)

// includes
#include "windows.h"
#include "../GL/GLee.h"
//#include "gl/glu.h"
#include "l3dsrenderer.h"
#include "../tex/TGAImage.hpp"
#include "../tex/texturemanager.h"
#include <direct.h>

#include <map>
#include <string>
#include <fstream>

#define BUFFER_OFFSET(i) ((char *)NULL + (i))


//static bool assertTGA(char *filename);

//class TextureManager
//{
//public:
//	static GLuint load(const std::string &filename);
//private:
//	static std::map<std::string, GLuint> m_textures;
//};
//std::map<std::string, GLuint> TextureManager::m_textures;
//
//GLuint TextureManager::load(const std::string &filename)
//{
//	if (filename.empty()) return 0;
//	
//	GLuint texture;
//	
//	std::map<std::string, GLuint>::iterator it = m_textures.find(filename);
//	
//	if (it != m_textures.end())
//		texture = it->second;
//	else
//	{
//		glGenTextures(1, &texture);
//		bleifrei::img::TGAImage image(std::ifstream((filename).c_str(), std::ios::binary));
//		glBindTexture(GL_TEXTURE_2D, texture);
//		{
//			switch (image.getFormat()) {
//			case bleifrei::img::ImageFormatL8 :
//				gluBuild2DMipmaps(GL_TEXTURE_2D, 1, image.getWidth(), image.getHeight(), GL_LUMINANCE, GL_UNSIGNED_BYTE, image.getData());
//				break;
//			case bleifrei::img::ImageFormatA8 :
//				gluBuild2DMipmaps(GL_TEXTURE_2D, 1, image.getWidth(), image.getHeight(), GL_ALPHA, GL_UNSIGNED_BYTE, image.getData());
//				break;
//				//case 16 :
//				//glTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE16, image.getWidth(), image.getHeight(), 0, GL_LUMINANCE, GL_UNSIGNED_SHORT, image.getData());
//				//gluBuild2DMipmaps(GL_TEXTURE_2D, 1, image.getWidth(), image.getHeight(), GL_LUMINANCE16, GL_UNSIGNED_SHORT, image.getData());
//				//break;
//			case bleifrei::img::ImageFormatR8G8B8 :
//				gluBuild2DMipmaps(GL_TEXTURE_2D, 3, image.getWidth(), image.getHeight(), GL_RGB, GL_UNSIGNED_BYTE, image.getData());
//				break;
//			case bleifrei::img::ImageFormatB8G8R8 :
//				gluBuild2DMipmaps(GL_TEXTURE_2D, 3, image.getWidth(), image.getHeight(), GL_BGR_EXT, GL_UNSIGNED_BYTE, image.getData());
//				break;
//			case bleifrei::img::ImageFormatR8G8B8A8 :
//				gluBuild2DMipmaps(GL_TEXTURE_2D, 4, image.getWidth(), image.getHeight(), GL_RGBA, GL_UNSIGNED_BYTE, image.getData());
//				break;
//			case bleifrei::img::ImageFormatB8G8R8A8 :
//				gluBuild2DMipmaps(GL_TEXTURE_2D, 4, image.getWidth(), image.getHeight(), GL_BGRA_EXT, GL_UNSIGNED_BYTE, image.getData());
//				break;
//			default:
//				printf("Unsupported tga format\n");
//			}
//		}
//		m_textures.insert(std::map<std::string, GLuint>::value_type(filename, texture));
//	}
//	
//	return texture;
//}

L3DSRenderer::~L3DSRenderer()
{
	if(m_bUseVertexBufferObjects)
	{
		for(unsigned int i=0; i<m_vboID.size(); i++)		// m_vboID.size() == m_vboID.size()
		{
			glDeleteBuffersARB(1, &m_vboID[i]);	
			glDeleteBuffersARB(1, &m_elID[i]);
		}
	}
}
void
L3DSRenderer::SetLights(void)
{
	// setup light
	float light0Position[] = {0.0f, 200.0f, 200.0f, 1.0f};
	float light0Ambient[] =  {0.5f, 0.5f, 0.5f, 1.0f};
	float light0Diffuse[] =  {0.75f, 0.75f, 0.75f, 1.0f};
	float light0Specular[] =  {0.25f, 0.25f, 0.25f, 1.0f};

	glLightfv(GL_LIGHT0, GL_POSITION, light0Position);
	glLightfv(GL_LIGHT0, GL_AMBIENT, light0Ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light0Diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, light0Specular);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);

	// enable depth test
	glEnable(GL_DEPTH_TEST);
}

void
L3DSRenderer::RenderOGL(bool backfaceCulling, bool bOnlyGeo)
{
	if(!m_bInitiated)
		init();

	glPushAttrib(GL_ALL_ATTRIB_BITS);

	if (backfaceCulling) 
		glEnable(GL_CULL_FACE);
	else
		glDisable(GL_CULL_FACE);

	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE, GL_REPLACE); //GL_MODULATE

	RenderObject(bOnlyGeo);

	glPopAttrib();
}

void
L3DSRenderer::CreateDisplayList(unsigned int list, unsigned int mode, bool bOnlyGeo)
{
	if(!m_bInitiated)
		init();
	
	glPushAttrib(GL_ALL_ATTRIB_BITS); // Do before display list start. Otherwise, it is compiled into display list

	glNewList(list, mode);
	RenderObject(bOnlyGeo);
	glEndList();
	
	glPopAttrib();
}

void
L3DSRenderer::RenderObject(bool bOnlyGeo)
{
	// loop through all meshes in the scene
	int totNumTris=0;
	int mtrlGroup=0;
	for (unsigned int i = 0; i < GetMeshCount(); ++i)
	{
		LMesh &mesh = GetMesh(i);

//		if(m_bUseVertexBufferObjects)
//			glBindBufferARB(GL_ARRAY_BUFFER_ARB, m_vboID[i]);

		if(!m_bUseVertexBufferObjects)
		{
			glVertexPointer(4, GL_FLOAT, 0, m_bUseVertexBufferObjects ? 0 : &(mesh.GetVertex(0)));
			glNormalPointer(GL_FLOAT, 0, m_bUseVertexBufferObjects ? (void*) (mesh.GetVertexCount()*4*sizeof(float)) : (const void*) &(mesh.GetNormal(0)));
//			glColorPointer(3, GL_FLOAT, 0, &mesh.GetBinormal(0));
		}
		
		if(m_bUseVertexBufferObjects)
			glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER, m_elID[i]);
		
		// loop through all triangles
		totNumTris += mesh.GetTriangleCount();
		if(bOnlyGeo)
		{
			// setup pointers to data and render mesh
			glEnableClientState(GL_VERTEX_ARRAY);
			glDrawElements(GL_TRIANGLES, mesh.GetTriangleCount() * 3, GL_UNSIGNED_SHORT, m_bUseVertexBufferObjects ? 0 : &(mesh.GetTriangle(0)));
			glDisableClientState(GL_VERTEX_ARRAY);
		}
		else
		{
			glEnableClientState(GL_VERTEX_ARRAY);
			glEnableClientState(GL_NORMAL_ARRAY);
			//	glEnableClientState(GL_COLOR_ARRAY);
			for(unsigned int j=0; j<mesh.GetTriangleCount(); )
			{
				// set up material
				struct LTriangle2 &tri = mesh.GetTriangle2(j);
				uint materialId =  tri.materialId;

				if(materialId != -1)
				{
					LMaterial& mtrl = GetMaterial(materialId); // returns the pointer to the material

					// setup material
					LColor3 col;
					col = mtrl.GetSpecularColor();
					float spec[] = {col.r, col.g, col.b, 1.0f};
					col = mtrl.GetAmbientColor();
					float ambient[] = {col.r, col.g, col.b, 1.0f};
					col = mtrl.GetDiffuseColor();
					float diff[] = {col.r, col.g, col.b, 1.0f};
					float emission[] = {0,0,0, 1.0f};

					glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, spec);
					glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mtrl.GetShininess());
					glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ambient);
					glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, diff);
					glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, emission);

					// check for textures
					LMap& map = mtrl.GetTextureMap1();
					if(map.mapName[0] != '\0') // there is a texture
					{
						glActiveTexture(GL_TEXTURE0 + 0); // activate tex unit 0

						GLuint tex = TextureManager::load(map.mapName);
						glBindTexture(GL_TEXTURE_2D, tex);
						glEnable(GL_TEXTURE_2D);
						glEnableClientState(GL_TEXTURE_COORD_ARRAY);
						if(!m_bUseVertexBufferObjects) glTexCoordPointer(2, GL_FLOAT, 0, &(mesh.GetUV(0)));

						glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
						glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
						glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
						glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR); // this is nicest available mipmap interpolation

					}
					else
					{
						glDisable(GL_TEXTURE_2D);
						glDisableClientState(GL_TEXTURE_COORD_ARRAY);
					}
				}
				else
				{
					glDisable(GL_TEXTURE_2D);
					glDisableClientState(GL_TEXTURE_COORD_ARRAY);
					// setup default material
					float spec[] = {0, 0, 0, 1.0f};
					float ambient[] = {0.2f, 0.2f, 0.2f, 1.0f};
					float diff[] = {0.8f, 0.8f, 0.8f, 1.0f};
					float emission[] = {0,0,0, 1.0f};

					glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, spec);
					glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 0);
					glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ambient);
					glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, diff);
					glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, emission);
				}

				// draw all tris with same material
				int nGroupTris = m_materialGroups[mtrlGroup++]; // k-j

				// setup pointers to data and render mesh
				glDrawElements(GL_TRIANGLES, nGroupTris * 3, GL_UNSIGNED_SHORT, m_bUseVertexBufferObjects ? BUFFER_OFFSET(j*3*sizeof(unsigned short)) : (char*)&(mesh.GetTriangle(j)));

				j += nGroupTris;
			}

			//	glDisableClientState(GL_COLOR_ARRAY);
			glDisableClientState(GL_NORMAL_ARRAY);
			glDisableClientState(GL_VERTEX_ARRAY);
		}
	}

	if(m_bUseVertexBufferObjects)
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, 0);
	
}

void
L3DSRenderer::init()
{
	if(m_bInitiated)
		return;

	//m_texManager.init();
	// loop through all meshes in the scene
	int totNumTris=0;
	
	m_vboID.resize(GetMeshCount());
	m_elID.resize(GetMeshCount());
	
	for (unsigned int i = 0; i < GetMeshCount(); ++i)
	{
		LMesh &mesh = GetMesh(i);
		totNumTris += mesh.GetTriangleCount();
		
		unsigned int j;
		for(j=0; j<mesh.GetVertexCount(); j++)
			m_bBox += Vec3f(mesh.GetVertex(j).x, mesh.GetVertex(j).y, mesh.GetVertex(j).z);
		
		
		// loop through all triangles
		bool bUsingTextures = false;
		for(j=0; j<mesh.GetTriangleCount(); )
		{
			// set up material
			struct LTriangle2 &tri = mesh.GetTriangle2(j);
			uint materialId =  tri.materialId;

			if(materialId >= GetMaterialCount())
				materialId = -1;

			// Objects without materials, also have materialId == -1
			if(materialId != -1)
			{
				LMaterial& mtrl = GetMaterial(materialId); // returns the pointer to the material

				// check for textures
				LMap& map = mtrl.GetTextureMap1();
				if(map.mapName[0] != '\0') // there is a texture
				{
					bUsingTextures = true;
					if(TextureManager::assertTGA(map.mapName))
						TextureManager::load(map.mapName);
				}
			}

			// draw all tris with same material
			unsigned int k=j+1;
			while (k<mesh.GetTriangleCount()) 
			{
				LTriangle2 &tri = mesh.GetTriangle2(k);
				if(materialId != tri.materialId)
					break;
				k++;
			}
			m_materialGroups.push_back(k-j);
			j=k;
		}

		// Create a vertex buffer object per mesh. Indices makes it hard to create one per l3ds-object (indices must then be offset, which can cause overflow for shorts. Changing to ints waste memory.)
		if(m_bUseVertexBufferObjects)
		{
			glGenBuffersARB(1, &m_vboID[i]);
			glGenBuffersARB(1, &m_elID[i]);
			
			// Create index buffer object
			glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, m_elID[i]);
			glBufferDataARB(GL_ELEMENT_ARRAY_BUFFER_ARB, mesh.GetTriangleCount()*3*sizeof(unsigned short), &(mesh.GetTriangle(0)), GL_STATIC_DRAW_ARB);
			//			int *tmp = new int[mesh.GetTriangleCount()*3];
			//			for(int a=0; a<mesh.GetTriangleCount()*3; a++)
			//				tmp[a] = *((short*)&(mesh.GetTriangle(0)) + a);
			//			glBufferDataARB(GL_ELEMENT_ARRAY_BUFFER_ARB, mesh.GetTriangleCount()*3*sizeof(int), tmp, GL_STATIC_DRAW_ARB);
			
			// Create array buffer object
			int size = 4+3 + (bUsingTextures ? 2 : 0);
			glBindBufferARB(GL_ARRAY_BUFFER_ARB, m_vboID[i]);
			glBufferDataARB(GL_ARRAY_BUFFER_ARB, mesh.GetVertexCount()*(size)*sizeof(float), 0, GL_STATIC_DRAW_ARB); // normals + vertices -> 6
			glBufferSubData(GL_ARRAY_BUFFER_ARB, 0, mesh.GetVertexCount()*4*sizeof(float), &(mesh.GetVertex(0))); 
			glBufferSubData(GL_ARRAY_BUFFER_ARB, mesh.GetVertexCount()*4*sizeof(float), mesh.GetVertexCount()*3*sizeof(float), &(mesh.GetNormal(0))); 	

			// when using vbo, this makes the copying of data!
			glVertexPointer(4, GL_FLOAT, 0, m_bUseVertexBufferObjects ? 0 : &(mesh.GetVertex(0)));
			glNormalPointer(GL_FLOAT, 0, m_bUseVertexBufferObjects ? (void*) (mesh.GetVertexCount()*4*sizeof(float)) : (const void*) &(mesh.GetNormal(0)));
			if(bUsingTextures)
			{
				glBufferSubData(GL_ARRAY_BUFFER_ARB, mesh.GetVertexCount()*7*sizeof(float), mesh.GetVertexCount()*2*sizeof(float), &(mesh.GetUV(0))); 	
				glTexCoordPointer(2, GL_FLOAT, 0, m_bUseVertexBufferObjects ? (void*) (mesh.GetVertexCount()*7*sizeof(float)) : (const void*) &(mesh.GetUV(0)));
			}
		}
		
	}
	if(m_bUseVertexBufferObjects)
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, 0);
	
	m_bvh = CollDet::createHierarchy(CollDet::T_AABB, *this);


	m_bInitiated = true;
}

bool L3DSRenderer::Load(const char* path, const char* filename)
{
	char buffer[_MAX_PATH];
	if( _getcwd( buffer, _MAX_PATH ) == NULL ) // Get the current working directory: 
	{
		perror( "_getcwd error" );
		return false;
	}

	if(_chdir(path))	// set working directory to "path"
	{
		printf( "Unable to locate the directory %s\n", path);
		return false;
	}

	LoadFile(filename); // Loads 3ds-model
	init();				// init while we are in the right directory
	_chdir(buffer);		// restore current working directory
	return true;
}

//// tries to convert file to tga (leaving original file intact), if not already in tga-format
//// Note: Possibly pollutes by leaving the possibly created tga-file on file system
//static bool assertTGA(char *filename)
//{
//	// call the image converter 'convert.exe ppmUnicodeFileName ppmTmpFileName'	
//	TCHAR args[2*MAX_PATH + 100];
//	args[0] = NULL;
//	TCHAR FileName0[2*MAX_PATH + 100];
//	TCHAR FileName1[2*MAX_PATH + 100];
//	int l=(int)strlen(filename);
//
//	// assert the original texture file exists
//	FILE *f;
//	f=fopen(filename,"rb");
//	if(f)
//		fclose(f);
//	else
//	{
//		*filename = '\0';
//		return false;
//	}
//
//	if(! strcmp(filename+l-4, ".tga")) // file is a tga-file
//		return true;
//
//	// compute name for the tga-file
//	for(int i=0; i<l; i++)
//	{
//		FileName0[i] = filename[i];
//		FileName1[i] = filename[i];
//		if(filename[i] == '.')
//		{
//			FileName1[i+1]=0;
//			lstrcat(FileName1, TEXT("tga"));
//			lstrcat(FileName1, "\0");
//
//			for(i++; i<l; i++)
//				FileName0[i] = filename[i];
//			FileName0[i]=0;
//			break;
//		}
//	}
//
//	// check if tga-file already exists, otherwise, convert
//	f=fopen(FileName1,"rb");
//	if(f)
//	{
//		fclose(f);
//		strcpy(filename, FileName1);
//		return true;
//	}
//
//	lstrcat(args, TEXT("convert.exe \""));
//	lstrcat(args, FileName0);
//	lstrcat(args, TEXT("\" \""));
//	lstrcat(args, FileName1);
//	lstrcat(args, TEXT("\""));
//	
//	//LPCSTR currentDirectory = szTempPath;		
//	STARTUPINFO startupInfo = {sizeof(STARTUPINFO), NULL, NULL, NULL, NULL, NULL, NULL, NULL,
//		NULL, NULL, NULL, NULL, NULL, NULL, NULL};
//	PROCESS_INFORMATION ProcessInformation; 
//	BOOL ok = CreateProcess(NULL, args, NULL, NULL, false,
//		CREATE_DEFAULT_ERROR_MODE | CREATE_NO_WINDOW, NULL, NULL, &startupInfo , &ProcessInformation);
//	if(!ok)
//	{
//		*filename = '\0';
//		return false;
//	}
//
//	// loop until tga file is created
//	for( i=0; i<100000; i++)
//	{
//		FILE *f;
//		f=fopen(FileName1,"rb");
//		if(f)
//		{
//			fclose(f);
//			strcpy(filename, FileName1);
//			return true;
//		}
//
//		MSG msg;
//		if (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
//		{
//			if (GetMessage(&msg, NULL, 0, 0))
//			{	
//				TranslateMessage(&msg);
//				DispatchMessage(&msg);
//			} else
//				exit(0);
//			//return msg.wParam;
//		} 
//	}
//	// The tga-file could not be created for some reason. Maybe original texture file is of a very unusual format.
//	*filename = '\0';
//	return false;
//}

