/*
 * $Author: niklas $
 * $Date: 2004/07/05 17:36:44 $
 * $Log: timer.cpp,v $
 * Revision 1.1.1.1  2004/07/05 17:36:44  niklas
 * no message
 *
 * Revision 1.5.2.2  2004/03/23 17:18:21  mats
 * Linux fixes
*/

#include "timer.h"
#include <iostream>

#ifndef LINUX
#include <windows.h>
#endif


#ifndef LINUX
#define rdtsc __asm __emit 0fh __asm __emit 031h
#define cpuid __asm __emit 0fh __asm __emit 0a2h

__declspec(naked) __int64 getCycleCount()
{ 
	__asm 
	{
		rdtsc
		ret
	}
}
#endif

Timer::Timer()
{
	init();
	calculateFrequency();
	//std::cout << (long)m_frequency << std::endl;
}

Timer::Timer(const Timer& timer)
{
	m_start = timer.m_start;
	m_adjust = timer.m_adjust;
	m_frequency = timer.m_frequency;
	
}

Timer::~Timer()
{
}

void Timer::init()
{
	// get the time it takes to run the timer
	// run a few time to get rid of cache misses
	__int64 adjust = 0;
	m_adjust = 0;
	for(int i=0; i<100; i++)
	{
		start(); // time a stop
		stop();
		adjust += m_start;
		m_start = 0;
	}
	m_adjust = adjust / 100;
}

void Timer::calculateFrequency()
{
#ifndef LINUX
	__int64 hpStart;
	QueryPerformanceCounter((LARGE_INTEGER*)&hpStart);
	__int64 hpEnd = hpStart;
	__int64 rdtscStart = getCycleCount();
	while (hpEnd - hpStart < 10000)
	{
		QueryPerformanceCounter((LARGE_INTEGER*)&hpEnd);
	}
	__int64 rdtscElapsed = getCycleCount() - rdtscStart;
	__int64 hpElapsed = hpEnd - hpStart;
	__int64 hpFrequency;
	QueryPerformanceFrequency((LARGE_INTEGER*)&hpFrequency);

	float realTime = (1.0 / hpFrequency) * hpElapsed;
	int freqMHz = rdtscElapsed / realTime / 1e6;
	m_frequency = freqMHz * 1e6;
//	printf("S snabb r datan ! %d",m_frequency);
#else
	m_frequency = (__int64)(3 * 1e9); // Kalibrerad fr Mats dator!
#endif
}
