#ifndef MP3D_NATURE_H
#define MP3D_NATURE_H

#include "vecmath.h"
#include "object.h"
#include <vector>


class CNature
{
public:
	CNature() : m_mountainID(-1) {};
	~CNature() {};

	// Mountain methods
	void renderMountain();
	void createMountain();
	float getHeight(float x, float z); // Returns height at position in the height field. The height field is oriented in the xz-plane,

	// Tree methods
	void createTrees();
	void renderTrees(Camera cam);

private:
	void loadShaders();
	
	Vec3f		 m_offset;
	Vec3f		 m_scale;

	unsigned int m_mountainID;
	Vec3f		 m_mountainMesh[100][100];
	GLhandleARB	 m_mtFragShader;			// mountain fragment shader
	GLhandleARB	 m_mtVertShader;			// mountain vertex shader
	GLhandleARB	 m_mtProgram;				// mountain vertex- and fragment program
	
	std::vector<Object*> m_trees;
	std::vector<Vec3f>	 m_treePositions;
	static L3DSRenderer  m_treeModel;
	static int			 m_treeTexID;
};
#endif // MP3D_NATURE_H