#ifndef LEVEL_H
#define LEVEL_H

#include "vecmath.h"

class CNavigation
{
public:
	CNavigation() 
	{
		assignKeys();
	};

	virtual ~CNavigation() {};

	void handleInput(int delta_x, int delta_y);

	void assignKeys();

private:

	//--- Navigation System ---
	// strafe left
	// strafe right
	// forward
	// backward
	// up
	// down
	// turn left
	// turn right
	// turn up
	// turn down
	//
	// height max
	// height min
	// lock upvec

	short m_strafe_left;
	short m_strafe_right;
	short m_forward;
	short m_backward;
	short m_up;
	short m_down;
	short m_turn_left;
	short m_turn_right;
	short m_turn_up;
	short m_turn_down;

	// second (alternative) keys
	short m_alt_strafe_left;		
	short m_alt_strafe_right;	
	short m_alt_forward;		
	short m_alt_backward;	
	short m_alt_turn_left;
	short m_alt_turn_right;
	short m_alt_turn_up;
	short m_alt_turn_down;
	
public:
	float m_max_height;
	float m_min_height;
	bool  m_lock_upvec;

	float m_speed;
	float m_turnSpeed;
	float m_max_up_down_rot; // in radians. Max rotation in up-down direction

	Vec3f m_upvec;
	Vec3f m_lookFrom;
	Vec3f m_lookAt;

private:

};


#endif
