#ifndef SOCKETS_SW_H
#define SOCKETS_SW_H

struct sockaddr_in;

// This class uses BROADCASTing for simplicity, I.e., limited LAN-broadcasting.
// In this way, multiplayer-game communication within the same LAN is automatic.
// No server is needed and no ip-addresses need to be specified.
// However, it is not nice to the network.
// Better would be to broadcast sporadically to detect new players and use multicast to the
// specific ip-adresses of the players.
// For outside LAN-communication, set the ip-address in the send-method to the desired address
class CMiniSockets
{
public:
	CMiniSockets();
	~CMiniSockets();

	// The port is what identifies the communication channel.
	// Set the port to a application-specific value between 1024 and 65535.
	void createSendSocket(int port); // Creates a sending socket
	void createRecvSocket(int port); // Creates a receiving socket

	void sendMessage(const char* str, int len); // str should be null-terminated string of max 1024 bytes
	const char* receiveMessage();	   //  
	
private:
	int				m_port;
	char			m_buffer[1024];	// Care must be taken if this is larger than 1500 bytes - the standard message size. Overflow will cause sending of several packages. Receiving socket treats it as several messages.
	unsigned int	m_socketID;
	sockaddr_in*	m_RecvAddr;
	
};

#endif
