#include "windows.h"
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>

#ifndef DXLIB
#define DXLIB
// IntertainmenT Software - Copyright 1999
// DirectX (Game) Programming Library (for DirectX 6.1+)

// #defines
#define bpp 16

//extern HWND main_window_handle; // save the window handle
extern HINSTANCE main_instance; // save the instance

// Classes

class CMusic
{
public:
	IDirectMusicSegment			*dms;	// DirectMusic segment
	IDirectMusicSegmentState	*dmss;	// DirectMusic segment state
	int							state;	// state of MIDI

	CMusic ( void )
	{
		state = 0;
	}

	~CMusic ()
	{
		state = 0;
	}

	int LoadMIDI (char *filename);
	int Play ( void );
	int Stop ( void );
	bool isPlaying ( void );
	int Release ( void );
};

class CSound
{
public:
	LPDIRECTSOUNDBUFFER buffer;
	int	state;
	int rate;
	int size;

	int Setup ( int size, int flags );	// finito
	int Release ( void );		// finito
	int LoadSound ( char *name );  // finito
	int SetVolume ( int volume );  // finito
	int SetFrequency ( int freq ); // finito
	int SetPan ( int pan );		// finito
	int Play ( bool loop );		// finito
	int Stop ( void );			// finito
	int Pause ( void );			// finito
};



// DirectSound
extern LPDIRECTSOUND lpds; // ds object
extern DSBUFFERDESC dsbd;	// ds buffer desc
extern WAVEFORMATEX pcmfx;	// holds format desc

// DirectMusic
extern IDirectMusicPerformance	*dmp;	// DirectMusic Performance
extern IDirectMusicLoader *dml;			// DirectMusic Loader

// Prototypes
void TableSetup (void);

// DIRECTMUSIC FUNCTIONS
int DMusic_Setup ( void );
int DMusic_Release ( void );

// DIRECTSOUND FUNCTIONS
int DSound_Setup ( void );
int DSound_Release ( void );

#endif