#ifndef BASS_CSOUND_H
#define BASS_CSOUND_H

// Wrapper class CBassSound written by Ulf Assarsson, 2006-06-06



class CBassSound
{
public:
	CBassSound();
	~CBassSound();

	void loadMP3(const char* file);
	void loadWav(const char* file);
	void unload();

	void play();
	void pause();
	void restart();
	
	void pauseAllSounds();
	void resumeAllSounds();

	void setAttributes(int vol = -1, int pan = -101, int freq = -1); // default values results in no change of that parameter
		
	float getCPUUsage();
		
private:
	enum		 { STREAM, SAMPLE };
	int			 m_type;
	unsigned int m_handle;
	
};


#endif	//BASS_CSOUND_H

