#ifndef TEXTUREMANAGER_H
#define TEXTUREMANAGER_H

#include <map>
#include <string>

class TextureManager
{
public:
	static GLuint load(const std::string &filename);

	//---------------------------------------------------------------------------------------------
	// This method either sets the alpha to zero for all texels matching the given transp-color
	// or, sets alpha to the intensity of the texel
	static GLuint load(const std::string &filename, unsigned char transp[3], bool bSetAlphaToIntensity=false);
	//---------------------------------------------------------------------------------------------
	
	static bool assertTGA(char *filename);
	
private:
	static std::map<std::string, GLuint> m_textures;
};

#endif
